Loading...
Searching...
No Matches
casacore::PlainColumn Class Referenceabstract
tables package (libcasa_tables) » Tables_module » Tables_module_internal_classes

More...

`#include <PlainColumn.h>`

## Public Member Functions

| PlainColumn (const BaseColumnDesc *, ColumnSet *)
virtual | ~PlainColumn ()
virtual Bool | isWritable () const
| Test if the column is in principle writable.
virtual Bool | isStored () const
| Test if the column is stored (otherwise it is virtual).
TableRecord & | rwKeywordSet ()
| Get access to the column keyword set.
TableRecord & | keywordSet ()
rownr_t | nrow () const
| Get nr of rows in the column.
virtual void | setShapeColumn (const IPosition &shape)
| Define the shape of all arrays in the column.
virtual Bool | isBound () const
| Test if the column is bound to a storage manager or virtual column engine.
virtual void | bind (DataManager *)
| Bind the column to a data manager.
virtual void | createDataManagerColumn ()=0
| Create a data manager column for a filled column.
DataManager * | dataManager () const
| Get the pointer to the data manager.
DataManagerColumn *& | dataManagerColumn ()
| Get the pointer to the data manager column.
virtual ColumnCache & | columnCache ()
| Get a pointer to the underlying column cache.
virtual void | setMaximumCacheSize (uInt nbytes)
| Set the maximum cache size (in bytes) to be used by a storage manager.
void | putFile (AipsIO &, const TableAttr &)
| Write the column.
void | getFile (AipsIO &, const ColumnSet &, const TableAttr &)
| Read the column.
Public Member Functions inherited from casacore::BaseColumn
| BaseColumn (const BaseColumnDesc *)
| Construct it using the given column description.
virtual | ~BaseColumn ()
const ColumnDesc & | columnDesc () const
| Get const access to the column description.
virtual Bool | isDefined (rownr_t rownr) const =0
| Test if the given cell contains a defined value.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of the array in the given row.
virtual void | setShape (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of the array in the given row.
virtual uInt | ndimColumn () const
| Get the global #dimensions of an array (ie.
virtual IPosition | shapeColumn () const
| Get the global shape of an array (ie.
virtual uInt | ndim (rownr_t rownr) const
| Get the #dimensions of an array in a particular cell.
virtual IPosition | shape (rownr_t rownr) const
| Get the shape of an array in a particular cell.
virtual IPosition | tileShape (rownr_t rownr) const
| Get the tile shape of an array in a particular cell.
virtual Bool | canChangeShape () const
| Ask the data manager if the shape of an existing array can be changed.
virtual void | initialize (rownr_t startRownr, rownr_t endRownr)=0
| Initialize the rows from startRow till endRow (inclusive) with the default value defined in the column description.
virtual void | get (rownr_t rownr, void *dataPtr) const
| Get a scalar value from a particular cell.
virtual void | getArray (rownr_t rownr, ArrayBase &dataPtr) const
| Get an array from a particular cell.
virtual void | getSlice (rownr_t rownr, const Slicer &, ArrayBase &dataPtr) const
| Get a slice of an N-dimensional array in a particular cell.
virtual void | getScalarColumn (ArrayBase &dataPtr) const
| Get the vector of all scalar values in a column.
virtual void | getArrayColumn (ArrayBase &dataPtr) const
| Get the array of all array values in a column.
virtual void | getColumnSlice (const Slicer &, ArrayBase &dataPtr) const
| Get subsections from all arrays in the column.
virtual void | getScalarColumnCells (const RefRows &rownrs, ArrayBase &dataPtr) const
| Get the vector of some scalar values in a column.
virtual void | getArrayColumnCells (const RefRows &rownrs, ArrayBase &dataPtr) const
| Get the array of some array values in a column.
virtual void | getColumnSliceCells (const RefRows &rownrs, const Slicer &, ArrayBase &dataPtr) const
| Get subsections from some arrays in the column.
virtual void | put (rownr_t rownr, const void *dataPtr)
| Put the scalar value in a particular cell.
virtual void | putArray (rownr_t rownr, const ArrayBase &dataPtr)
| Put the array value in a particular cell.
virtual void | putSlice (rownr_t rownr, const Slicer &, const ArrayBase &dataPtr)
| Put a slice of an N-dimensional array in a particular cell.
virtual void | putScalarColumn (const ArrayBase &dataPtr)
| Put the vector of all scalar values in the column.
virtual void | putArrayColumn (const ArrayBase &dataPtr)
| Put the array of all array values in the column.
virtual void | putColumnSlice (const Slicer &, const ArrayBase &dataPtr)
| Put into subsections of all table arrays in the column.
virtual void | putScalarColumnCells (const RefRows &rownrs, const ArrayBase &dataPtr)
| Get the vector of some scalar values in a column.
virtual void | putArrayColumnCells (const RefRows &rownrs, const ArrayBase &dataPtr)
| Get the array of some array values in a column.
virtual void | putColumnSliceCells (const RefRows &rownrs, const Slicer &, const ArrayBase &dataPtr)
| Put subsections of some arrays in the column.
void | getScalar (rownr_t rownr, Bool &value) const
| Get the value from the row and convert it to the required type.
void | getScalar (rownr_t rownr, uChar &value) const
void | getScalar (rownr_t rownr, Short &value) const
void | getScalar (rownr_t rownr, uShort &value) const
void | getScalar (rownr_t rownr, Int &value) const
void | getScalar (rownr_t rownr, uInt &value) const
void | getScalar (rownr_t rownr, Int64 &value) const
void | getScalar (rownr_t rownr, float &value) const
void | getScalar (rownr_t rownr, double &value) const
void | getScalar (rownr_t rownr, Complex &value) const
void | getScalar (rownr_t rownr, DComplex &value) const
void | getScalar (rownr_t rownr, String &value) const
void | getScalar (rownr_t rownr, TableRecord &value) const
void | getScalar (rownr_t rownr, void *value, const String &dataTypeId) const
| Get a scalar for the other data types.
void | putScalar (rownr_t rownr, const Bool &value)
| Put the value into the row and convert it from the given type.
void | putScalar (rownr_t rownr, const uChar &value)
void | putScalar (rownr_t rownr, const Short &value)
void | putScalar (rownr_t rownr, const uShort &value)
void | putScalar (rownr_t rownr, const Int &value)
void | putScalar (rownr_t rownr, const uInt &value)
void | putScalar (rownr_t rownr, const Int64 &value)
void | putScalar (rownr_t rownr, const float &value)
void | putScalar (rownr_t rownr, const double &value)
void | putScalar (rownr_t rownr, const Complex &value)
void | putScalar (rownr_t rownr, const DComplex &value)
void | putScalar (rownr_t rownr, const String &value)
void | putScalar (rownr_t rownr, const Char *value)
void | putScalar (rownr_t rownr, const TableRecord &value)
virtual void | makeSortKey (Sort &, std::shared_ptr< BaseCompare > &cmpObj, Int order, std::shared_ptr< ArrayBase > &dataSave)
| Add this column and its data to the Sort object.
virtual void | makeRefSortKey (Sort &, std::shared_ptr< BaseCompare > &cmpObj, Int order, const Vector< rownr_t > &rownrs, std::shared_ptr< ArrayBase > &dataSave)
| Do it only for the given row numbers.
virtual void | allocIterBuf (void *&lastVal, void *&curVal, std::shared_ptr< BaseCompare > &cmpObj)
| Allocate value buffers for the table iterator.
virtual void | freeIterBuf (void *&lastVal, void *&curVal)
| Free the value buffers allocated by allocIterBuf.

## Protected Member Functions

int | traceId () const
| Get the trace-id of the table.
virtual void | putFileDerived (AipsIO &)=0
| Write the column.
virtual void | getFileDerived (AipsIO &, const ColumnSet &)=0
| Read the column back.
void | checkValueLength (const void *) const
| Check the length of a value.
void | checkValueLength (const String *value) const
void | checkValueLength (const Array< String > *value) const
void | checkReadLock (Bool wait) const
| Lock the table before reading or writing.
void | checkWriteLock (Bool wait) const
void | autoReleaseLock () const
| Inspect the auto lock when the inspection interval has expired and release it when another process needs the lock.
Protected Member Functions inherited from casacore::BaseColumn
void | throwGetScalar () const
| Throw exceptions for invalid scalar get or put.
void | throwPutScalar () const
void | throwGetType (const String &type) const
void | throwPutType (const String &type) const

## Protected Attributes

DataManager * | dataManPtr_p
DataManagerColumn * | dataColPtr_p
ColumnSet * | colSetPtr_p
String | originalName_p
Bool | rtraceColumn_p
Bool | wtraceColumn_p
Protected Attributes inherited from casacore::BaseColumn
const BaseColumnDesc * | colDescPtr_p

## Detailed Description

Base class for a column in a plain table

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- BaseColumn
- PlainTable

### Etymology

PlainColumn represents any column in a plain table. A plain table is a regular table, i.e. not a table like a RefTable which is a view on a plain table.

### Synopsis

Abstract base class for all types of columns in a plain table. It implements the common functionality for all columns in a plain table. Furthermore it defines some virtual functions (on top of the virtual functions defined in BaseColumn) which are specific for plain columns.

Definition at line 82 of file PlainColumn.h.

## Constructor & Destructor Documentation

## PlainColumn()

casacore::PlainColumn::PlainColumn | ( | const BaseColumnDesc * | ,
|  | ColumnSet * | )

## ~PlainColumn()

virtual casacore::PlainColumn::~PlainColumn | ( |  | ) |

virtual

## Member Function Documentation

## autoReleaseLock()

void casacore::PlainColumn::autoReleaseLock | ( |  | ) | const

inline protected

Inspect the auto lock when the inspection interval has expired and release it when another process needs the lock.

Definition at line 195 of file PlainColumn.h.

References colSetPtr_p.

## bind()

virtual void casacore::PlainColumn::bind | ( | DataManager * |  | ) |

virtual

Bind the column to a data manager.

## checkReadLock()

void casacore::PlainColumn::checkReadLock | ( | Bool | wait | ) | const

inline protected

Lock the table before reading or writing.

If manual or permanent locking is in effect, it checks if the table is locked.

Definition at line 191 of file PlainColumn.h.

References colSetPtr_p.

## checkValueLength() [1/3]

void casacore::PlainColumn::checkValueLength | ( | const Array< String > * | value | ) | const

protected

References casacore::NewDelAllocator< T >::value.

## checkValueLength() [2/3]

void casacore::PlainColumn::checkValueLength | ( | const String * | value | ) | const

protected

References casacore::NewDelAllocator< T >::value.

## checkValueLength() [3/3]

void casacore::PlainColumn::checkValueLength | ( | const void * |  | ) | const

inline protected

Check the length of a value.

This a meant for String values for which a maximum length is defined. The void* version is a no-op for other values.

Definition at line 188 of file PlainColumn.h.

## checkWriteLock()

void casacore::PlainColumn::checkWriteLock | ( | Bool | wait | ) | const

inline protected

Definition at line 193 of file PlainColumn.h.

References colSetPtr_p.

## columnCache()

virtual ColumnCache & casacore::PlainColumn::columnCache | ( |  | ) |

virtual

Get a pointer to the underlying column cache.

Implements casacore::BaseColumn.

## createDataManagerColumn()

virtual void casacore::PlainColumn::createDataManagerColumn | ( |  | ) |

pure virtual

Create a data manager column for a filled column.

Implemented in casacore::ArrayColumnData, casacore::ScalarColumnData< T >, and casacore::ScalarRecordColumnData.

## dataManager()

DataManager * casacore::PlainColumn::dataManager | ( |  | ) | const

inline

Get the pointer to the data manager.

Definition at line 183 of file PlainColumn.h.

References dataManPtr_p.

## dataManagerColumn()

DataManagerColumn *& casacore::PlainColumn::dataManagerColumn | ( |  | ) |

inline

Get the pointer to the data manager column.

Definition at line 185 of file PlainColumn.h.

References dataColPtr_p.

## getFile()

void casacore::PlainColumn::getFile | ( | AipsIO & | ,
|  | const ColumnSet & | ,
|  | const TableAttr & | )

Read the column.

## getFileDerived()

virtual void casacore::PlainColumn::getFileDerived | ( | AipsIO & | ,
|  | const ColumnSet & | )

protected pure virtual

Read the column back.

The control information is read from the given AipsIO object. This is used to bind the column to the appropriate data manager.

Implemented in casacore::ArrayColumnData, casacore::ScalarColumnData< T >, and casacore::ScalarRecordColumnData.

## isBound()

virtual Bool casacore::PlainColumn::isBound | ( |  | ) | const

virtual

Test if the column is bound to a storage manager or virtual column engine.

## isStored()

virtual Bool casacore::PlainColumn::isStored | ( |  | ) | const

virtual

Test if the column is stored (otherwise it is virtual).

Implements casacore::BaseColumn.

## isWritable()

virtual Bool casacore::PlainColumn::isWritable | ( |  | ) | const

virtual

Test if the column is in principle writable.

This does not test if the table itself is writable. That has to be done by the caller.

Implements casacore::BaseColumn.

## keywordSet()

TableRecord & casacore::PlainColumn::keywordSet | ( |  | ) |

virtual

Implements casacore::BaseColumn.

## nrow()

rownr_t casacore::PlainColumn::nrow | ( |  | ) | const

virtual

Get nr of rows in the column.

Implements casacore::BaseColumn.

## putFile()

void casacore::PlainColumn::putFile | ( | AipsIO & | ,
|  | const TableAttr & | )

Write the column.

## putFileDerived()

virtual void casacore::PlainColumn::putFileDerived | ( | AipsIO & |  | ) |

protected pure virtual

Write the column.

The control information is written into the given AipsIO object, while the data is written by the storage manager.

Implemented in casacore::ArrayColumnData, casacore::ScalarColumnData< T >, and casacore::ScalarRecordColumnData.

## rwKeywordSet()

TableRecord & casacore::PlainColumn::rwKeywordSet | ( |  | ) |

virtual

Get access to the column keyword set.

Implements casacore::BaseColumn.

## setMaximumCacheSize()

virtual void casacore::PlainColumn::setMaximumCacheSize | ( | uInt | nbytes | ) |

virtual

Set the maximum cache size (in bytes) to be used by a storage manager.

Implements casacore::BaseColumn.

## setShapeColumn()

virtual void casacore::PlainColumn::setShapeColumn | ( | const IPosition & | shape | ) |

virtual

Define the shape of all arrays in the column.

Reimplemented in casacore::ArrayColumnData.

References casacore::BaseColumn::shape().

## traceId()

int casacore::PlainColumn::traceId | ( |  | ) | const

inline protected

Get the trace-id of the table.

Definition at line 147 of file PlainColumn.h.

References colSetPtr_p.

## Member Data Documentation

## colSetPtr_p

ColumnSet* casacore::PlainColumn::colSetPtr_p

protected

Definition at line 141 of file PlainColumn.h.

Referenced by autoReleaseLock(), checkReadLock(), checkWriteLock(), and traceId().

## dataColPtr_p

DataManagerColumn* casacore::PlainColumn::dataColPtr_p

protected

Definition at line 140 of file PlainColumn.h.

Referenced by dataManagerColumn().

## dataManPtr_p

DataManager* casacore::PlainColumn::dataManPtr_p

protected

Definition at line 139 of file PlainColumn.h.

Referenced by dataManager().

## originalName_p

String casacore::PlainColumn::originalName_p

protected

Definition at line 142 of file PlainColumn.h.

## rtraceColumn_p

Bool casacore::PlainColumn::rtraceColumn_p

protected

Definition at line 143 of file PlainColumn.h.

## wtraceColumn_p

Bool casacore::PlainColumn::wtraceColumn_p

protected

Definition at line 144 of file PlainColumn.h.

The documentation for this class was generated from the following file:

- tables/Tables/PlainColumn.h